Bug 88592 - VLAN Tagging problem on VLAN Interfaces
VLAN Tagging problem on VLAN Interfaces
Status: CLOSED WONTFIX
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
9
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeff Garzik
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-04-11 01:55 EDT by Tarhon-Onu Victor
Modified: 2013-07-02 22:10 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:40:47 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tarhon-Onu Victor 2003-04-11 01:55:17 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.3) Gecko/20030314

Description of problem:
The NIC drivers from the linux kernel must be pached in order not to drop
"oversized frames" received. A tagged frame has a suplimentary header (tag)
which contains informations about the vlan id it comes from, etc. The tagged
frames are 4 bytes longer that the normal untagged ethernet frames. Almost all
NIC drivers from the linux kernel (except e100 I suppose) drop this frames
because are considered being oversized before untagging them.

What happens: let's suppose you have some users/workstations behind such a
router (having vlan subinterfaces for each users vlan), and let's look at the
problem from the primary interface (that handling their vlan). Then sending a
frame to one of them that frame will go out via, let's say, eth7.700. The the
frame will pe tagged (vlan tag will be added to the frame) and the frame goes
out to the trunk port from the switch via eth7. This is ok.
      When the user sends a frame to the router it has the following route: user
switch -untagged-> switch port from user's vlan -tagging-> trunk ports between
switches or router and switch -> router's primary interface -untagging->
router's vlan subinterface.

If the frame is too big (max ethernet frame size - 4bytes +1 byte) then the vlan
tag is added it will be dropped by the most nic drivers.


Version-Release number of selected component (if applicable):
Upload problem via a linux router having 802.1Q VLAN subinterfaces

How reproducible:
Always

Steps to Reproduce:
1. configure a router with vlan subinterfaces.
2. connect it in a trunk port havind 802.1Q encapsulation form a managed
ethernet switch
3. from a user connected in the vlan coresponding to the vlan subinterface try
to upload something to a host behind the router.
    

Actual Results:  After the first big packet (the first packet bigger that 1496
bytes) the upload will freeze.

Additional info:

Tested with 3c59x, ne2k-pci (8390), 8139too, sis900 and eepro100 drivers. e100
seems to work without patch (anyway I patched it in my customized kernels).

I think also the guys from kernel.org should think about patching the nic
drivers to work properly with 802.1Q tags. There is vlan support in kernel since  
2.4.14.
Comment 1 acount closed by user 2003-05-01 13:35:13 EDT
yes, a lot of drivers do not support vlan.
And you need to patch the drivers:
http://www.geocities.co.jp/AnimeComic-White/6586/vlan-e.html
http://www.candelatech.com/~greear/vlan/howto.html

good luck, because vlan in linux is a mess of drivers
Comment 2 Bugzilla owner 2004-09-30 11:40:47 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.